<template>
  <div>
    <div v-if="!player">
      Loading Game...
    </div>
    <div v-if="player">
      <input type="text" placeholder="Player Name" v-model="playerName">
      <resource :resource="'tr'" :friction="10" :amount="player.tr"></resource> <br>
      <resource :resource="'me'" :friction="2" :amount="player.me" :production="player.meP"></resource> <br>
      <resource :resource="'steel'" :friction="6" :amount="player.steel" :production="player.steelP"></resource> <br>
      <resource :resource="'titanium'" :friction="6" :amount="player.titanium" :production="player.titaniumP"></resource> <br>
      <resource :resource="'plants'" :friction="6" :amount="player.plants" :production="player.plantsP"></resource> <br>
      <resource :resource="'energy'" :friction="6" :amount="player.energy" :production="player.energyP"></resource> <br>
      <resource :resource="'heat'" :friction="6" :amount="player.heat" :production="player.heatP"></resource> <br>
      <button @click="produce">Produce</button>
    </div>
  </div>
</template>

<script>
import Resource from './Resource';
import debounce from 'lodash/debounce';

export default {
  name: 'production-sheet',
  computed: {
    player () {
      if (this.$store.state.game) {
        return this.$store.state.game[this.$store.state.playerId];
      }
    }
  },
  data () {
    return {
      playerName: this.$store.state.playerName
    };
  },
  watch: {
    playerName () {
      this.setPlayerName();
    }
  },
  methods: {
    produce () {
      this.$store.dispatch('produce');
    },
    setPlayerName: debounce(function () {
      this.$store.dispatch('setPlayerName', { playerName: this.playerName });
    }, 500)
  },
  components: {
    Resource
  }
};
</script>

<style scoped>

</style>
